import React from 'react';
import reactDOM from 'react-dom';
import PropTypes from 'prop-types';
import { PluginKey } from '@bangle.dev/core/prosemirror/state';
import { LinkSubMenu } from './LinkSubMenu';
import { usePluginState } from '@bangle.dev/react';
import { CodeButton, TodoListButton, BoldButton, ItalicButton, BulletListButton, HeadingButton, FloatingLinkButton, } from './MenuButtons';
import { Menu } from './Menu';
import { MenuGroup } from './MenuGroup';
export function FloatingMenu({ menuKey, renderMenuType = ({ type, menuKey }) => {
    if (type === 'defaultMenu') {
        return (React.createElement(Menu, null,
            React.createElement(MenuGroup, null,
                React.createElement(BoldButton, null),
                React.createElement(ItalicButton, null),
                React.createElement(CodeButton, null),
                React.createElement(FloatingLinkButton, { menuKey: menuKey })),
            React.createElement(MenuGroup, null,
                React.createElement(HeadingButton, { level: 2 }),
                React.createElement(HeadingButton, { level: 3 }),
                React.createElement(BulletListButton, null),
                React.createElement(TodoListButton, null))));
    }
    if (type === 'linkSubMenu') {
        return (React.createElement(Menu, null,
            React.createElement(LinkSubMenu, null)));
    }
    return null;
}, }) {
    const menuState = usePluginState(menuKey);
    const renderElement = renderMenuType({ type: menuState.type, menuKey });
    return renderElement
        ? reactDOM.createPortal(renderElement, menuState.tooltipContentDOM)
        : null;
}
FloatingMenu.propTypes = {
    menuKey: PropTypes.instanceOf(PluginKey).isRequired,
    renderMenuType: PropTypes.func,
};
